
Auto Multiple Choice - Bug # 489: Aucun modèle n'apparait dans la fenêtre de sélection des modèles 
lors de la création d'un nouveau projet

Status: Closed Priority: Normal
Author: Joël Brogniart Category:
Created: 07/04/2017 Assignee:
Updated: 02/13/2018 Due date:
Description: Sous macOS 10.12.5 avec AMC 2066 commit:cc3f6c129dd0

Lorsqu'on crée un nouveau projet en sélectionnant l'option "Modèle", la fenêtre de choix du modèle est vide, 
même si le dossier "~/.AMC.d/Models" contient des modèles.

Je joins un fichier debug. Ce fichier correspond aux manupulations suivantes.

- Je lance AMC.
- J'active le mode debug.
- Je choisis le menu "Projet > Nouveau"
- Dans la fenêtre "Nouveau projet QCM" j'indique le nom "toto" et je clique le bouton "Créer un projet".
- Dans la fenêtre "Choix du source LaTex" je laisse activé le bouton "Modèle" et je clique sur le bouton 
"Suivant".
- La fenêtre "Choix du modèle" apparait avec une liste de modèles vide.
- Je clique sur le bouton "Annuler" mais la fenêtre ne se ferme pas.
- Je clique sur le bouton de fermeture dans la barre de fenêtre et la fenêtre disparait.
- Je choisis le menu 'Projet > Ouvrir".
- Je choisis un projet existant.
- Une fois le projet ouvert, je choisis le menu "Projet > Exporter comme modèle", je remplis des informations 
pour le modèle et je clique sur le bouton "Valider".
- Je choisis à nouveau le menu "Projet > Nouveau"
- Dans la fenêtre "Nouveau projet QCM" j'indique le nom "toto" et je clique le bouton "Créer un projet".
- Dans la fenêtre "Choix du source LaTex" je laisse activé le bouton "Modèle" et je clique sur le bouton 
"Suivant".
- La fenêtre "Choix du modèle" apparait toujours avec une liste de modèles vide.
- Je clique sur le bouton de fermeture dans la barre de fenêtre et la fenêtre disparait.
- Je désactive le mode debug.

Le dossier "~/.AMC.d/Models" contient bien les modèles originaux AMC ainsi que le modèle que j'ai créé.

History
07/11/2017 10:50 am - Alexis Bienvenüe
Quel est le contenu du dossier @~/.AMC.d/Models@ ? Y a-t-il uniquement des fichiers archive (@zip@, @tgz@), ou d'autres choses ?

07/11/2017 11:29 am - Alexis Bienvenüe
Pouvez-vous essayer avec la version commit:388d69e2a5f7, en lançant AMC depuis la ligne de commande, et me dire si il y a quelque chose 
d'intéressant dans la sortie ?

07/11/2017 11:31 am - Joël Brogniart
Voici le contenu.
Les fichiers ".DS_Store" sont générés par macOS.

<pre>
ls -alR ~/.AMC.d
total 40
drwxr-xr-x   7 julesvernes  staff   238 18 jan 12:54 .
drwxr-xr-x+ 85 julesvernes  staff  2890 10 jul 10:01 ..
-rw-r--r--@  1 julesvernes  staff  6148 18 jan 13:02 .DS_Store
drwxr-xr-x  10 julesvernes  staff   340  4 jul 12:39 Models
-rw-r--r--@  1 julesvernes  staff  5779  4 jul 12:49 cf.default.xml
drwxr-xr-x   2 julesvernes  staff    68 14 déc  2012 plugins
-rw-r--r--@  1 julesvernes  staff   335 17 déc  2012 state.xml

/Users/julesvernes/.AMC.d/Models:
total 72
drwxr-xr-x  10 julesvernes  staff   340  4 jul 12:39 .
drwxr-xr-x   7 julesvernes  staff   238 18 jan 12:54 ..
-rw-r--r--@  1 julesvernes  staff  6148  4 jul 12:39 .DS_Store
-rw-r--r--   1 julesvernes  staff    20  4 jul 09:32 Pre-remplies-ensemble.tgz
-rw-r--r--   1 julesvernes  staff    20  4 jul 09:32 Pre-remplies.tgz
-rw-r--r--   1 julesvernes  staff  1310  4 jul 09:32 bareme.tgz
-rw-r--r--   1 julesvernes  staff  1492  4 jul 09:32 ensemble.tgz
-rw-r--r--   1 julesvernes  staff  1150  4 jul 09:32 groupes.tgz
-rw-r--r--   1 julesvernes  staff   585  4 jul 09:32 simple-txt.tgz
-rw-r--r--   1 julesvernes  staff  1121  4 jul 09:32 simple.tgz

/Users/julesvernes/.AMC.d/plugins:
total 0
drwxr-xr-x  2 julesvernes  staff   68 14 déc  2012 .
drwxr-xr-x  7 julesvernes  staff  238 18 jan 12:54 ..
</pre>

07/11/2017 11:36 am - Alexis Bienvenüe
Les fichiers @Pre-remplies-ensemble.tgz@ et @Pre-remplies.tgz@ sont-ils valides ? C'est un peu bizarre qu'ils ne fassent que 20 octets.

07/11/2017 11:52 am - Joël Brogniart
- File Capture_dâ��Ã©cran_2017-07-11_Ã _11.48.51.png added

Ça a l'air de fonctionner avec la version commit:388d69e2a5f7.

J'arrive à créer un projet à partir d'un modèle. Par contre dans la liste qui apparait, il y a des trucs bizarres genre "[AR] Documentation" (voir image 
jointe).

Voici ce que j'ai dans ma fenêtre de terminal au lancement d'AMC (je lance AMC, je crée un projet "Toto", je choisis un modèle et je quitte).

<pre>
Gtk-Message: GtkDialog mapped without a transient parent. This is discouraged.
Gtk-Message: GtkDialog mapped without a transient parent. This is discouraged.
Gtk-Message: GtkDialog mapped without a transient parent. This is discouraged.
WARNING: Could not read archive file "/Users/brogniar/.AMC.d/Models/Pre-remplies-ensemble.tgz" ...
WARNING: Could not read archive file "/Users/brogniar/.AMC.d/Models/Pre-remplies.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/ar/groups.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/ar/scoring.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/ar/separate.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/ar/simple.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/en/Nominative-sheets-separateanswersheet.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/en/Nominative-sheets.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/fr/Pre-remplies-ensemble.tgz" ...
WARNING: Could not read archive file "/opt/local/share/auto-multiple-choice/models/fr/Pre-remplies.tgz" ...
x ensemble.tex
x description.xml
x options.xml
"\x{00e7}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 41.
"\x{00ea}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00ee}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00ea}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00e0}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00e8}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00ea}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00ea}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5430, <SRC> line 91.
"\x{00e0}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5432, <SRC> line 112.
"\x{00ea}" does not map to MacCentralEurRoman at /opt/local/lib/AMC/perl/AMC-gui.pl line 5432, <SRC> line 112.
</pre>

07/11/2017 12:51 pm - Joël Brogniart
Je viens de trouver d'où vient le problème. Il est peut-être spécifique à macOS. Lors de la construction des modèles, il sont construits de la manière 
suivante.
<pre>:info:build tar cn -C modeles/ar/groups.d  -O . | gzip  -c > modeles/ar/groups.tgz</pre>

La commande échoue.
<pre>:info:build tar: Option -O is not permitted in mode -c</pre>

Les modèles pourraient être créés en utilisant la compression directement dans la commande tar.

<pre>tar -czf modeles/ar/groups.tgz modeles/ar/groups.d</pre>

L'option z pour la compression et l'option f pour préciser le fichier de sortie.

07/11/2017 01:11 pm - Joël Brogniart
Argg, je me suis trompé dans ma commande, j'avais oublié qu'il y avait toute une hiérarchie. Il faudrait plutôt la commande suivante.
<pre>tar czf modeles/ar/groups.tgz -C modeles/ar/groups.d .</pre>

07/11/2017 02:14 pm - Joël Brogniart
Bon j'ai essayé de remplacer
<pre>tar cn -C $< $(TAR_REPRODUCIBLE_ARGS) -O . | gzip $(GZIP_REPRODUCIBLE_ARGS) -c > $@</pre>

par
<pre>tar cnzf $(GZIP_REPRODUCIBLE_ARGS) -C $< $(TAR_REPRODUCIBLE_ARGS) . > $@</pre>

dans @doc/Makefile@ et ce n'est pas encore ça. Certains modèles sont vides et d'autres non.

En fait, le problème provient des options @-n@ et @-O@.

Ça fonctionne à nouveau avec dans la ligne 98 de doc/Makefile
<pre>tar -c $(TAR_REPRODUCIBLE_ARGS) -C $<  . | gzip $(GZIP_REPRODUCIBLE_ARGS) -c > $@</pre>
ou
<pre>tar -cz $(TAR_REPRODUCIBLE_ARGS) $(GZIP_REPRODUCIBLE_ARGS) -f $@ -C $< . </pre>
les archives/modèles sont générés correctement.

Et si j'efface le dossier  @~/.AMC.d/Model@, les modèles sont bien recréés pour l'utilisateur et bien rangés par langue.
07/13/2017 09:35 am - Joël Brogniart
Serait-il possible de modifier la ligne 98 de @doc/Makefile@ avec

<pre>tar -c $(TAR_REPRODUCIBLE_ARGS) -C $<  . | gzip $(GZIP_REPRODUCIBLE_ARGS) -c > $@</pre>

et d'utiliser la variable @TAR_REPRODUCIBLE_ARGS@ pour mettre les options @n@ et @O@ pour les plateformes qui ont besoin des ces options?

11/20/2017 10:21 am - Alexis Bienvenüe
Bon, le problème vient de la syntaxe différente de tar suivant la plate-forme, qui rend les choses incompatibles entre elles. Il me semble que la version 
BSD n'a pas d'options qui permettent d'obtenir une archive reproductible.
Je propose donc la solution suivante :
* Mettre @TAR_REPRODUCIBLE_ARGS=nonreproducible@ dans @Makefile-macports.conf@
* Changer la cible @%.tgz@ dans @doc/Makefile@ de la manière suivante :
<pre>
%.tgz: %.d
	find $< -type d -exec chmod 0755 '{}' \;
	find $< -type f -exec chmod 0644 '{}' \;
ifeq ($(TAR_REPRODUCIBLE_ARGS),nonreproducible)
	tar -cz -f $@ -C $< . 
else
	tar cn -C $< $(TAR_REPRODUCIBLE_ARGS) -O . | gzip $(GZIP_REPRODUCIBLE_ARGS) -c > $@
endif
</pre>

Est-ce que cela vous paraît raisonnable et résoud le problème de votre côté ?

11/20/2017 11:07 am - Joël Brogniart
Je viens de tester avec ces modifications et tout se passe bien. Ça me parait donc raisonnable et ça résoud le problème. Merci.

11/20/2017 02:45 pm - Alexis Bienvenüe
- Status changed from New to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:15d39fd2d4aa.

02/13/2018 12:59 pm - Alexis Bienvenüe
- Status changed from Resolved to Closed
